unit fmChartTest;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, VclTee.TeeGDIPlus, VclTee.TeEngine, VclTee.Series, Vcl.ExtCtrls,
  VclTee.TeeProcs, VclTee.Chart, Vcl.StdCtrls, dxGDIPlusClasses, cxGraphics, cxControls, cxLookAndFeels,
  cxLookAndFeelPainters, cxContainer, cxEdit, dxSkinsCore, Softdrill_NL, cxImage, cxLabel;

type
  TForm1 = class(TForm)
    btnCopy: TButton;
    imgChart: TImage;
    cbLabelsRight: TCheckBox;
    cbLabelsBottom: TCheckBox;
    btnRectangle: TButton;
    chtTest: TChart;
    Series1: TLineSeries;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnCopyClick(Sender: TObject);
    procedure btnRectangleClick(Sender: TObject);
  private
    { Private declarations }
    FChart: TChart;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.btnRectangleClick(Sender: TObject);
var
  myRect: TRect;
begin
  chtTest.Canvas.Pen.Color := clRed;
  chtTest.Canvas.Pen.Width := 2;
  chtTest.Canvas.Brush.Style := bsClear;
  myRect := chtTest.ChartRect;
  chtTest.Canvas.Rectangle(myRect, 0);
end;

procedure TForm1.btnCopyClick(Sender: TObject);
var
  myRect: TRect;
begin
  FChart.Axes.Right.LabelsFormat.Visible := cbLabelsRight.Checked;
  FChart.Axes.Bottom.LabelsFormat.Visible := cbLabelsBottom.Checked;
  FChart.CustomChartRect := true;
  myRect := imgChart.ClientRect;
  InflateRect(myRect, FChart.Axes.Right.MaxLabelsWidth + FChart.Axes.Right.TickLength + 2,
    Abs(FChart.Axes.Bottom.LabelsFont.Height) + FChart.Axes.Bottom.TickLength + 5);
  FChart.ChartRect := myRect;
  myRect := imgChart.ClientRect;
  FChart.TeeCreateBitmap(clWhite, myRect);
  imgChart.Picture.Bitmap := FChart.TeeCreateBitmap(clWhite, myRect);
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  mySeries: TChartSeries;
begin
  FChart := TChart.Create(nil);

  FChart.View3D := false;
  FChart.Legend.Visible := false;
  FChart.Color := clRed;

  FChart.BackWall.Frame.Visible := false;
  FChart.BackWall.Gradient.Visible := false;
  FChart.BackWall.Color := clWhite;
  FChart.BackWall.Transparent := false;

  FChart.Axes.Right.Automatic := false;
  FChart.Axes.Right.Minimum := 0;
  FChart.Axes.Right.Maximum := 1000;
  FChart.Axes.Right.Inverted := true;
  FChart.Axes.Right.PositionPercent := 100;
  FChart.Axes.Right.LabelsOnAxis := false;
  FChart.Axes.Right.Visible := true;
  FChart.Axes.Right.Axis.Visible := false;
  FChart.Axes.Right.LabelsFormat.Visible := cbLabelsRight.Checked;
  FChart.Axes.Right.Grid.DrawAlways := true;
  FChart.Axes.Right.MinimumOffset := 50;

  FChart.Axes.Bottom.Automatic := false;
  FChart.Axes.Bottom.Minimum := 0;
  FChart.Axes.Bottom.Maximum := 100;
  FChart.Axes.Bottom.PositionPercent := 100;
  FChart.Axes.Bottom.LabelsOnAxis := false;
  FChart.Axes.Bottom.Visible := true;
  FChart.Axes.Bottom.Axis.Visible := false;
  FChart.Axes.Bottom.LabelsFormat.Visible := cbLabelsBottom.Checked;
  FChart.Axes.Bottom.Grid.DrawAlways := true;
  FChart.Axes.Bottom.MinimumOffset := 50;

  FChart.FreeAllSeries;
  mySeries := FChart.AddSeries(TLineSeries);
  mySeries.VertAxis := aRightAxis;
  mySeries.HorizAxis := aBottomAxis;
  mySeries.FillSampleValues(30);

  chtTest.Series[0].FillSampleValues(30);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FChart.FreeAllSeries;
  FChart.Free;
end;

end.
